$(function() {
var diagram = $("#diagram").dxDiagram({
customShapes: [
{
category: "hardware",
type: "internet",
title: "Internet",
backgroundImageUrl: "../../../../images/shapes/internet.svg",
backgroundImageLeft: 0.15,
backgroundImageTop: 0,
backgroundImageWidth: 0.7,
backgroundImageHeight: 0.7,
defaultWidth: 0.75,
defaultHeight: 0.75,
defaultText: "Internet",
allowEditText: true,
textLeft: 0,
textTop: 0.7,
textWidth: 1,
textHeight: 0.3,
connectionPoints: [
{ x: 0.5, y: 0 },
{ x: 0.9, y: 0.5 },
{ x: 0.5, y: 1 },
{ x: 0.1, y: 0.5 }
]
},
{
category: "hardware",
type: "laptop",
title: "Laptop",
backgroundImageUrl: "../../../../images/shapes/laptop.svg",
backgroundImageLeft: 0.15,
backgroundImageTop: 0,
backgroundImageWidth: 0.7,
backgroundImageHeight: 0.7,
defaultWidth: 0.75,
defaultHeight: 0.75,
defaultText: "Laptop",
allowEditText: true,
textLeft: 0,
textTop: 0.7,
textWidth: 1,
textHeight: 0.3,
connectionPoints: [
{ x: 0.5, y: 0 },
{ x: 0.9, y: 0.5 },
{ x: 0.5, y: 1 },
{ x: 0.1, y: 0.5 }
]
},
{
category: "hardware",
type: "mobile",
title: "Mobile",
backgroundImageUrl: "../../../../images/shapes/mobile.svg",
backgroundImageLeft: 0.15,
backgroundImageTop: 0,
backgroundImageWidth: 0.7,
backgroundImageHeight: 0.7,
defaultWidth: 0.75,
defaultHeight: 0.75,
defaultText: "Mobile",
allowEditText: true,
textLeft: 0,
textTop: 0.7,
textWidth: 1,
textHeight: 0.3,
connectionPoints: [
{ x: 0.5, y: 0 },
{ x: 0.9, y: 0.5 },
{ x: 0.5, y: 1 },
{ x: 0.1, y: 0.5 }
]
},
{
category: "hardware",
type: "pc",
title: "PC",
backgroundImageUrl: "../../../../images/shapes/pc.svg",
backgroundImageLeft: 0.15,
backgroundImageTop: 0,
backgroundImageWidth: 0.7,
backgroundImageHeight: 0.7,
defaultWidth: 0.75,
defaultHeight: 0.75,
defaultText: "PC",
allowEditText: true,
textLeft: 0,
textTop: 0.7,
textWidth: 1,
textHeight: 0.3,
connectionPoints: [
{ x: 0.5, y: 0 },
{ x: 0.9, y: 0.5 },
{ x: 0.5, y: 1 },
{ x: 0.1, y: 0.5 }
]
},
{
category: "hardware",
type: "phone",
title: "Phone",
backgroundImageUrl: "../../../../images/shapes/phone.svg",
backgroundImageLeft: 0.15,
backgroundImageTop: 0,
backgroundImageWidth: 0.7,
backgroundImageHeight: 0.7,
defaultWidth: 0.75,
defaultHeight: 0.75,
defaultText: "Phone",
allowEditText: true,
textLeft: 0,
textTop: 0.7,
textWidth: 1,
textHeight: 0.3,
connectionPoints: [
{ x: 0.5, y: 0 },
{ x: 0.9, y: 0.5 },
{ x: 0.5, y: 1 },
{ x: 0.1, y: 0.5 }
]
},
{
category: "hardware",
type: "printer",
title: "Printer",
backgroundImageUrl: "../../../../images/shapes/printer.svg",
backgroundImageLeft: 0.15,
backgroundImageTop: 0,
backgroundImageWidth: 0.7,
backgroundImageHeight: 0.7,
defaultWidth: 0.75,
defaultHeight: 0.75,
defaultText: "Printer",
allowEditText: true,
textLeft: 0,
textTop: 0.7,
textWidth: 1,
textHeight: 0.3,
connectionPoints: [
{ x: 0.5, y: 0 },
{ x: 0.9, y: 0.5 },
{ x: 0.5, y: 1 },
{ x: 0.1, y: 0.5 }
]
},
{
category: "hardware",
type: "router",
title: "Router",
backgroundImageUrl: "../../../../images/shapes/router.svg",
backgroundImageLeft: 0.15,
backgroundImageTop: 0,
backgroundImageWidth: 0.7,
backgroundImageHeight: 0.7,
defaultWidth: 0.75,
defaultHeight: 0.75,
defaultText: "Router",
allowEditText: true,
textLeft: 0,
textTop: 0.7,
textWidth: 1,
textHeight: 0.3,
},
{
category: "hardware",
type: "scaner",
title: "Scaner",
backgroundImageUrl: "../../../../images/shapes/scaner.svg",
backgroundImageLeft: 0.15,
backgroundImageTop: 0,
backgroundImageWidth: 0.7,
backgroundImageHeight: 0.7,
defaultWidth: 0.75,
defaultHeight: 0.75,
defaultText: "Scaner",
allowEditText: true,
textLeft: 0,
textTop: 0.7,
textWidth: 1,
textHeight: 0.3,
connectionPoints: [
{ x: 0.5, y: 0 },
{ x: 0.9, y: 0.5 },
{ x: 0.5, y: 1 },
{ x: 0.1, y: 0.5 }
]
},
{
category: "hardware",
type: "server",
title: "Server",
backgroundImageUrl: "../../../../images/shapes/server.svg",
backgroundImageLeft: 0.15,
backgroundImageTop: 0,
backgroundImageWidth: 0.7,
backgroundImageHeight: 0.7,
defaultWidth: 0.75,
defaultHeight: 0.75,
defaultText: "Server",
allowEditText: true,
textLeft: 0,
textTop: 0.7,
textWidth: 1,
textHeight: 0.3,
connectionPoints: [
{ x: 0.5, y: 0 },
{ x: 0.9, y: 0.5 },
{ x: 0.5, y: 1 },
{ x: 0.1, y: 0.5 }
]
},
{
category: "hardware",
type: "switch",
title: "Switch",
backgroundImageUrl: "../../../../images/shapes/switch.svg",
backgroundImageLeft: 0.15,
backgroundImageTop: 0,
backgroundImageWidth: 0.7,
backgroundImageHeight: 0.7,
defaultWidth: 0.75,
defaultHeight: 0.75,
defaultText: "Switch",
allowEditText: true,
textLeft: 0,
textTop: 0.7,
textWidth: 1,
textHeight: 0.3,
connectionPoints: [
{ x: 0.5, y: 0 },
{ x: 0.9, y: 0.5 },
{ x: 0.5, y: 1 },
{ x: 0.1, y: 0.5 }
]
},
{
category: "hardware",
type: "wifi",
title: "Wi Fi Router",
backgroundImageUrl: "../../../../images/shapes/wifi.svg",
backgroundImageLeft: 0.15,
backgroundImageTop: 0,
backgroundImageWidth: 0.7,
backgroundImageHeight: 0.7,
defaultWidth: 0.75,
defaultHeight: 0.75,
defaultText: "Wi Fi",
allowEditText: true,
textLeft: 0,
textTop: 0.7,
textWidth: 1,
textHeight: 0.3,
connectionPoints: [
{ x: 0.5, y: 0 },
{ x: 0.9, y: 0.5 },
{ x: 0.5, y: 1 },
{ x: 0.1, y: 0.5 }
]
}
],
toolbox: {
groups: [{ category: "hardware", title: "Hardware" }]
}
}).dxDiagram("instance");
$.ajax({
url: "../../../../data/diagram-hardware.json",
dataType: "text",
success: function(data) {
diagram.import(data);
}
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<script src="https://cdn3.devexpress.com/jslib/20.2.4/js/dx-diagram.min.js"></script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.4/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.4/css/dx.light.css" />
<link rel="stylesheet" href="https://cdn3.devexpress.com/jslib/20.2.4/css/dx-diagram.css" />
<script src="https://cdn3.devexpress.com/jslib/20.2.4/js/dx.all.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="diagram">
</div>
</div>
</body>
</html>
#diagram {
height: 900px;
}

DevExtreme v25.2 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

React Diagram - Background Images

The Diagram component provides a collection of built-in shapes. You can extend this collection with custom shapes.

An array of custom shape objects is accessible through the customShapes property. For each custom shape object, you can specify the type, background image, default size, text, connection points, and other settings. Note that shape images should be supplied as SVG files.

This demo shows how to populate the shape collection with custom shape types, and how to use custom shapes in the Diagram.

Backend API
import React, { useEffect, useRef } from 'react'; import Diagram, { CustomShape, ConnectionPoint, Group, Toolbox, } from 'devextreme-react/diagram'; import type { DiagramRef } from 'devextreme-react/diagram'; import 'whatwg-fetch'; export default function App() { const diagramRef = useRef<DiagramRef>(null); useEffect(() => { const diagram = diagramRef.current?.instance(); fetch('../../../../data/diagram-hardware.json') .then((response) => response.json()) .then((json) => { diagram?.import(JSON.stringify(json)); }) .catch(() => { throw new Error('Data Loading Error'); }); }, []); return ( <Diagram id="diagram" ref={diagramRef}> <CustomShape category="hardware" type="internet" title="Internet" backgroundImageUrl="../../../../images/shapes/internet.svg" backgroundImageLeft={0.15} backgroundImageTop={0} backgroundImageWidth={0.7} backgroundImageHeight={0.7} defaultWidth={0.75} defaultHeight={0.75} defaultText="Internet" allowEditText={true} textLeft={0} textTop={0.7} textWidth={1} textHeight={0.3}> <ConnectionPoint x={0.5} y={0} /> <ConnectionPoint x={0.9} y={0.5} /> <ConnectionPoint x={0.5} y={1} /> <ConnectionPoint x={0.1} y={0.5} /> </CustomShape> <CustomShape category="hardware" type="laptop" title="Laptop" backgroundImageUrl="../../../../images/shapes/laptop.svg" backgroundImageLeft={0.15} backgroundImageTop={0} backgroundImageWidth={0.7} backgroundImageHeight={0.7} defaultWidth={0.75} defaultHeight={0.75} defaultText="Laptop" allowEditText={true} textLeft={0} textTop={0.7} textWidth={1} textHeight={0.3}> <ConnectionPoint x={0.5} y={0} /> <ConnectionPoint x={0.9} y={0.5} /> <ConnectionPoint x={0.5} y={1} /> <ConnectionPoint x={0.1} y={0.5} /> </CustomShape> <CustomShape category="hardware" type="mobile" title="Mobile" backgroundImageUrl="../../../../images/shapes/mobile.svg" backgroundImageLeft={0.15} backgroundImageTop={0} backgroundImageWidth={0.7} backgroundImageHeight={0.7} defaultWidth={0.75} defaultHeight={0.75} defaultText="Mobile" allowEditText={true} textLeft={0} textTop={0.7} textWidth={1} textHeight={0.3}> <ConnectionPoint x={0.5} y={0} /> <ConnectionPoint x={0.9} y={0.5} /> <ConnectionPoint x={0.5} y={1} /> <ConnectionPoint x={0.1} y={0.5} /> </CustomShape> <CustomShape category="hardware" type="pc" title="PC" backgroundImageUrl="../../../../images/shapes/pc.svg" backgroundImageLeft={0.15} backgroundImageTop={0} backgroundImageWidth={0.7} backgroundImageHeight={0.7} defaultWidth={0.75} defaultHeight={0.75} defaultText="PC" allowEditText={true} textLeft={0} textTop={0.7} textWidth={1} textHeight={0.3}> <ConnectionPoint x={0.5} y={0} /> <ConnectionPoint x={0.9} y={0.5} /> <ConnectionPoint x={0.5} y={1} /> <ConnectionPoint x={0.1} y={0.5} /> </CustomShape> <CustomShape category="hardware" type="phone" title="Phone" backgroundImageUrl="../../../../images/shapes/phone.svg" backgroundImageLeft={0.15} backgroundImageTop={0} backgroundImageWidth={0.7} backgroundImageHeight={0.7} defaultWidth={0.75} defaultHeight={0.75} defaultText="Phone" allowEditText={true} textLeft={0} textTop={0.7} textWidth={1} textHeight={0.3}> <ConnectionPoint x={0.5} y={0} /> <ConnectionPoint x={0.9} y={0.5} /> <ConnectionPoint x={0.5} y={1} /> <ConnectionPoint x={0.1} y={0.5} /> </CustomShape> <CustomShape category="hardware" type="printer" title="Printer" backgroundImageUrl="../../../../images/shapes/printer.svg" backgroundImageLeft={0.15} backgroundImageTop={0} backgroundImageWidth={0.7} backgroundImageHeight={0.7} defaultWidth={0.75} defaultHeight={0.75} defaultText="Printer" allowEditText={true} textLeft={0} textTop={0.7} textWidth={1} textHeight={0.3}> <ConnectionPoint x={0.5} y={0} /> <ConnectionPoint x={0.9} y={0.5} /> <ConnectionPoint x={0.5} y={1} /> <ConnectionPoint x={0.1} y={0.5} /> </CustomShape> <CustomShape category="hardware" type="router" title="Router" backgroundImageUrl="../../../../images/shapes/router.svg" backgroundImageLeft={0.15} backgroundImageTop={0} backgroundImageWidth={0.7} backgroundImageHeight={0.7} defaultWidth={0.75} defaultHeight={0.75} defaultText="Router" allowEditText={true} textLeft={0} textTop={0.7} textWidth={1} textHeight={0.3}> </CustomShape> <CustomShape category="hardware" type="scaner" title="Scaner" backgroundImageUrl="../../../../images/shapes/scaner.svg" backgroundImageLeft={0.15} backgroundImageTop={0} backgroundImageWidth={0.7} backgroundImageHeight={0.7} defaultWidth={0.75} defaultHeight={0.75} defaultText="Scaner" allowEditText={true} textLeft={0} textTop={0.7} textWidth={1} textHeight={0.3}> <ConnectionPoint x={0.5} y={0} /> <ConnectionPoint x={0.9} y={0.5} /> <ConnectionPoint x={0.5} y={1} /> <ConnectionPoint x={0.1} y={0.5} /> </CustomShape> <CustomShape category="hardware" type="server" title="Server" backgroundImageUrl="../../../../images/shapes/server.svg" backgroundImageLeft={0.15} backgroundImageTop={0} backgroundImageWidth={0.7} backgroundImageHeight={0.7} defaultWidth={0.75} defaultHeight={0.75} defaultText="Server" allowEditText={true} textLeft={0} textTop={0.7} textWidth={1} textHeight={0.3}> <ConnectionPoint x={0.5} y={0} /> <ConnectionPoint x={0.9} y={0.5} /> <ConnectionPoint x={0.5} y={1} /> <ConnectionPoint x={0.1} y={0.5} /> </CustomShape> <CustomShape category="hardware" type="switch" title="Switch" backgroundImageUrl="../../../../images/shapes/switch.svg" backgroundImageLeft={0.15} backgroundImageTop={0} backgroundImageWidth={0.7} backgroundImageHeight={0.7} defaultWidth={0.75} defaultHeight={0.75} defaultText="Switch" allowEditText={true} textLeft={0} textTop={0.7} textWidth={1} textHeight={0.3}> <ConnectionPoint x={0.5} y={0} /> <ConnectionPoint x={0.9} y={0.5} /> <ConnectionPoint x={0.5} y={1} /> <ConnectionPoint x={0.1} y={0.5} /> </CustomShape> <CustomShape category="hardware" type="wifi" title="Wi Fi Router" backgroundImageUrl="../../../../images/shapes/wifi.svg" backgroundImageLeft={0.15} backgroundImageTop={0} backgroundImageWidth={0.7} backgroundImageHeight={0.7} defaultWidth={0.75} defaultHeight={0.75} defaultText="Wi Fi" allowEditText={true} textLeft={0} textTop={0.7} textWidth={1} textHeight={0.3}> <ConnectionPoint x={0.5} y={0} /> <ConnectionPoint x={0.9} y={0.5} /> <ConnectionPoint x={0.5} y={1} /> <ConnectionPoint x={0.1} y={0.5} /> </CustomShape> <Toolbox> <Group category={'hardware' as any} title="Hardware" /> </Toolbox> </Diagram> ); }
import React, { useEffect, useRef } from 'react'; import Diagram, { CustomShape, ConnectionPoint, Group, Toolbox, } from 'devextreme-react/diagram'; import 'whatwg-fetch'; export default function App() { const diagramRef = useRef(null); useEffect(() => { const diagram = diagramRef.current?.instance(); fetch('../../../../data/diagram-hardware.json') .then((response) => response.json()) .then((json) => { diagram?.import(JSON.stringify(json)); }) .catch(() => { throw new Error('Data Loading Error'); }); }, []); return ( <Diagram id="diagram" ref={diagramRef} > <CustomShape category="hardware" type="internet" title="Internet" backgroundImageUrl="../../../../images/shapes/internet.svg" backgroundImageLeft={0.15} backgroundImageTop={0} backgroundImageWidth={0.7} backgroundImageHeight={0.7} defaultWidth={0.75} defaultHeight={0.75} defaultText="Internet" allowEditText={true} textLeft={0} textTop={0.7} textWidth={1} textHeight={0.3} > <ConnectionPoint x={0.5} y={0} /> <ConnectionPoint x={0.9} y={0.5} /> <ConnectionPoint x={0.5} y={1} /> <ConnectionPoint x={0.1} y={0.5} /> </CustomShape> <CustomShape category="hardware" type="laptop" title="Laptop" backgroundImageUrl="../../../../images/shapes/laptop.svg" backgroundImageLeft={0.15} backgroundImageTop={0} backgroundImageWidth={0.7} backgroundImageHeight={0.7} defaultWidth={0.75} defaultHeight={0.75} defaultText="Laptop" allowEditText={true} textLeft={0} textTop={0.7} textWidth={1} textHeight={0.3} > <ConnectionPoint x={0.5} y={0} /> <ConnectionPoint x={0.9} y={0.5} /> <ConnectionPoint x={0.5} y={1} /> <ConnectionPoint x={0.1} y={0.5} /> </CustomShape> <CustomShape category="hardware" type="mobile" title="Mobile" backgroundImageUrl="../../../../images/shapes/mobile.svg" backgroundImageLeft={0.15} backgroundImageTop={0} backgroundImageWidth={0.7} backgroundImageHeight={0.7} defaultWidth={0.75} defaultHeight={0.75} defaultText="Mobile" allowEditText={true} textLeft={0} textTop={0.7} textWidth={1} textHeight={0.3} > <ConnectionPoint x={0.5} y={0} /> <ConnectionPoint x={0.9} y={0.5} /> <ConnectionPoint x={0.5} y={1} /> <ConnectionPoint x={0.1} y={0.5} /> </CustomShape> <CustomShape category="hardware" type="pc" title="PC" backgroundImageUrl="../../../../images/shapes/pc.svg" backgroundImageLeft={0.15} backgroundImageTop={0} backgroundImageWidth={0.7} backgroundImageHeight={0.7} defaultWidth={0.75} defaultHeight={0.75} defaultText="PC" allowEditText={true} textLeft={0} textTop={0.7} textWidth={1} textHeight={0.3} > <ConnectionPoint x={0.5} y={0} /> <ConnectionPoint x={0.9} y={0.5} /> <ConnectionPoint x={0.5} y={1} /> <ConnectionPoint x={0.1} y={0.5} /> </CustomShape> <CustomShape category="hardware" type="phone" title="Phone" backgroundImageUrl="../../../../images/shapes/phone.svg" backgroundImageLeft={0.15} backgroundImageTop={0} backgroundImageWidth={0.7} backgroundImageHeight={0.7} defaultWidth={0.75} defaultHeight={0.75} defaultText="Phone" allowEditText={true} textLeft={0} textTop={0.7} textWidth={1} textHeight={0.3} > <ConnectionPoint x={0.5} y={0} /> <ConnectionPoint x={0.9} y={0.5} /> <ConnectionPoint x={0.5} y={1} /> <ConnectionPoint x={0.1} y={0.5} /> </CustomShape> <CustomShape category="hardware" type="printer" title="Printer" backgroundImageUrl="../../../../images/shapes/printer.svg" backgroundImageLeft={0.15} backgroundImageTop={0} backgroundImageWidth={0.7} backgroundImageHeight={0.7} defaultWidth={0.75} defaultHeight={0.75} defaultText="Printer" allowEditText={true} textLeft={0} textTop={0.7} textWidth={1} textHeight={0.3} > <ConnectionPoint x={0.5} y={0} /> <ConnectionPoint x={0.9} y={0.5} /> <ConnectionPoint x={0.5} y={1} /> <ConnectionPoint x={0.1} y={0.5} /> </CustomShape> <CustomShape category="hardware" type="router" title="Router" backgroundImageUrl="../../../../images/shapes/router.svg" backgroundImageLeft={0.15} backgroundImageTop={0} backgroundImageWidth={0.7} backgroundImageHeight={0.7} defaultWidth={0.75} defaultHeight={0.75} defaultText="Router" allowEditText={true} textLeft={0} textTop={0.7} textWidth={1} textHeight={0.3} ></CustomShape> <CustomShape category="hardware" type="scaner" title="Scaner" backgroundImageUrl="../../../../images/shapes/scaner.svg" backgroundImageLeft={0.15} backgroundImageTop={0} backgroundImageWidth={0.7} backgroundImageHeight={0.7} defaultWidth={0.75} defaultHeight={0.75} defaultText="Scaner" allowEditText={true} textLeft={0} textTop={0.7} textWidth={1} textHeight={0.3} > <ConnectionPoint x={0.5} y={0} /> <ConnectionPoint x={0.9} y={0.5} /> <ConnectionPoint x={0.5} y={1} /> <ConnectionPoint x={0.1} y={0.5} /> </CustomShape> <CustomShape category="hardware" type="server" title="Server" backgroundImageUrl="../../../../images/shapes/server.svg" backgroundImageLeft={0.15} backgroundImageTop={0} backgroundImageWidth={0.7} backgroundImageHeight={0.7} defaultWidth={0.75} defaultHeight={0.75} defaultText="Server" allowEditText={true} textLeft={0} textTop={0.7} textWidth={1} textHeight={0.3} > <ConnectionPoint x={0.5} y={0} /> <ConnectionPoint x={0.9} y={0.5} /> <ConnectionPoint x={0.5} y={1} /> <ConnectionPoint x={0.1} y={0.5} /> </CustomShape> <CustomShape category="hardware" type="switch" title="Switch" backgroundImageUrl="../../../../images/shapes/switch.svg" backgroundImageLeft={0.15} backgroundImageTop={0} backgroundImageWidth={0.7} backgroundImageHeight={0.7} defaultWidth={0.75} defaultHeight={0.75} defaultText="Switch" allowEditText={true} textLeft={0} textTop={0.7} textWidth={1} textHeight={0.3} > <ConnectionPoint x={0.5} y={0} /> <ConnectionPoint x={0.9} y={0.5} /> <ConnectionPoint x={0.5} y={1} /> <ConnectionPoint x={0.1} y={0.5} /> </CustomShape> <CustomShape category="hardware" type="wifi" title="Wi Fi Router" backgroundImageUrl="../../../../images/shapes/wifi.svg" backgroundImageLeft={0.15} backgroundImageTop={0} backgroundImageWidth={0.7} backgroundImageHeight={0.7} defaultWidth={0.75} defaultHeight={0.75} defaultText="Wi Fi" allowEditText={true} textLeft={0} textTop={0.7} textWidth={1} textHeight={0.3} > <ConnectionPoint x={0.5} y={0} /> <ConnectionPoint x={0.9} y={0.5} /> <ConnectionPoint x={0.5} y={1} /> <ConnectionPoint x={0.1} y={0.5} /> </CustomShape> <Toolbox> <Group category="hardware" title="Hardware" /> </Toolbox> </Diagram> ); }
import React from 'react'; import ReactDOM from 'react-dom'; import App from './App.tsx'; ReactDOM.render( <App />, document.getElementById('app'), );
window.exports = window.exports || {}; window.config = { transpiler: 'ts', typescriptOptions: { module: 'system', emitDecoratorMetadata: true, experimentalDecorators: true, jsx: 'react', }, meta: { 'react': { 'esModule': true, }, 'typescript': { 'exports': 'ts', }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, 'openai': { 'esModule': true, }, }, paths: { 'npm:': 'https://cdn.jsdelivr.net/npm/', 'bundles:': '../../../../bundles/', 'externals:': '../../../../bundles/externals/', 'anti-forgery:': '../../../../shared/anti-forgery/', }, defaultExtension: 'js', map: { 'anti-forgery': 'anti-forgery:fetch-override.js', 'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js', 'typescript': 'npm:typescript@4.2.4/lib/typescript.js', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', 'react': 'npm:react@17.0.2/umd/react.development.js', 'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js', 'prop-types': 'npm:prop-types/prop-types.js', 'whatwg-fetch': 'npm:whatwg-fetch@2.0.4/fetch.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign', 'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs', 'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs', 'devextreme-quill': 'npm:devextreme-quill@1.7.8/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.25/dist/dx-diagram.js', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.67/dist/dx-gantt.js', 'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', '@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js', 'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3', // SystemJS plugins 'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js', 'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.8/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js', }, packages: { 'devextreme': { defaultExtension: 'js', }, 'devextreme-react': { main: 'index.js', }, 'devextreme-react/common': { main: 'index.js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/common/core/events/utils': { main: 'index', }, 'devextreme/localization/messages': { format: 'json', defaultExtension: 'json', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', ], babelOptions: { sourceMaps: false, stage0: true, react: true, }, }; window.process = { env: { NODE_ENV: 'production', }, }; System.config(window.config); // eslint-disable-next-line const useTgzInCSB = ['openai'];
import React from 'react'; import ReactDOM from 'react-dom'; import App from './App.js'; ReactDOM.render(<App />, document.getElementById('app'));
{ "page": { "width": 8400, "height": 11910, "pageColor": "white", "pageWidth": 8400, "pageHeight": 11910, "pageLandscape": false, "gridSize": 180, "showGrid": true, "snapToGrid": true, "units": 1 }, "connectors": [ { "key": "19", "locked": false, "zIndex": 0, "points": [ { "x": 4860, "y": 1620 }, { "x": 4860, "y": 2160 } ], "properties": { "endLineEnding": 0 }, "beginItemKey": "0", "beginConnectionPointIndex": 2, "endItemKey": "1", "endConnectionPointIndex": 0 }, { "key": "20", "locked": false, "zIndex": 0, "points": [ { "x": 4860, "y": 3240 }, { "x": 4860, "y": 5040 }, { "x": 3780, "y": 5040 }, { "x": 2700, "y": 5580 } ], "properties": { "endLineEnding": 0 }, "beginItemKey": "1", "beginConnectionPointIndex": 2, "endItemKey": "2", "endConnectionPointIndex": 0 }, { "key": "21", "locked": false, "zIndex": 0, "points": [ { "x": 4860, "y": 3240 }, { "x": 4860, "y": 5040 }, { "x": 7020, "y": 5040 }, { "x": 7020, "y": 5580 } ], "properties": { "endLineEnding": 0 }, "beginItemKey": "1", "beginConnectionPointIndex": 2, "endItemKey": "3", "endConnectionPointIndex": 0 }, { "key": "22", "locked": false, "zIndex": 0, "points": [ { "x": 2700, "y": 6660 }, { "x": 1980, "y": 7560 } ], "properties": { "endLineEnding": 0 }, "beginItemKey": "2", "beginConnectionPointIndex": 2, "endItemKey": "5", "endConnectionPointIndex": 0 }, { "key": "23", "locked": false, "zIndex": 0, "points": [ { "x": 2700, "y": 6660 }, { "x": 3240, "y": 7560 } ], "properties": { "endLineEnding": 0 }, "beginItemKey": "2", "beginConnectionPointIndex": 2, "endItemKey": "6", "endConnectionPointIndex": 0 }, { "key": "24", "locked": false, "zIndex": 0, "points": [ { "x": 2700, "y": 6660 }, { "x": 720, "y": 7560 } ], "properties": { "endLineEnding": 0 }, "beginItemKey": "2", "beginConnectionPointIndex": 2, "endItemKey": "4", "endConnectionPointIndex": 0 }, { "key": "25", "locked": false, "zIndex": 0, "points": [ { "x": 2700, "y": 6660 }, { "x": 4500, "y": 7560 } ], "properties": { "endLineEnding": 0 }, "beginItemKey": "2", "beginConnectionPointIndex": 2, "endItemKey": "7", "endConnectionPointIndex": 0 }, { "key": "27", "locked": false, "zIndex": 0, "points": [ { "x": 6300, "y": 8640 }, { "x": 6300, "y": 9000 }, { "x": 6300, "y": 9540 }, { "x": 6012, "y": 9540 } ], "properties": { "endLineEnding": 0 }, "beginItemKey": "9", "beginConnectionPointIndex": 2, "endItemKey": "10", "endConnectionPointIndex": 1 }, { "key": "28", "locked": false, "zIndex": 0, "points": [ { "x": 6300, "y": 8640 }, { "x": 6300, "y": 9000 }, { "x": 6300, "y": 10980 }, { "x": 6012, "y": 10980 } ], "properties": { "endLineEnding": 0 }, "beginItemKey": "9", "beginConnectionPointIndex": 2, "endItemKey": "11", "endConnectionPointIndex": 1 }, { "key": "29", "locked": false, "zIndex": 0, "points": [ { "x": 7020, "y": 6660 }, { "x": 6300, "y": 7560 } ], "properties": { "endLineEnding": 0 }, "beginItemKey": "3", "beginConnectionPointIndex": 2, "endItemKey": "9", "endConnectionPointIndex": 0 }, { "key": "30", "locked": false, "zIndex": 0, "points": [ { "x": 4320, "y": 2700 }, { "x": 2592, "y": 2700 } ], "properties": { "endLineEnding": 0 }, "beginItemKey": "1", "beginConnectionPointIndex": 3, "endItemKey": "12", "endConnectionPointIndex": 1 }, { "key": "31", "locked": false, "zIndex": 0, "points": [ { "x": 5400, "y": 2700 }, { "x": 7128, "y": 2700 } ], "properties": { "endLineEnding": 0 }, "beginItemKey": "1", "beginConnectionPointIndex": 1, "endItemKey": "13", "endConnectionPointIndex": 3 }, { "key": "32", "locked": false, "zIndex": 0, "points": [ { "x": 2160, "y": 3240 }, { "x": 2160, "y": 3780 } ], "properties": { "endLineEnding": 0 }, "beginItemKey": "12", "beginConnectionPointIndex": 2, "endItemKey": "14", "endConnectionPointIndex": 0 }, { "key": "33", "locked": false, "zIndex": 0, "points": [ { "x": 2160, "y": 3240 }, { "x": 3600, "y": 3780 } ], "properties": { "endLineEnding": 0 }, "beginItemKey": "12", "beginConnectionPointIndex": 2, "endItemKey": "15", "endConnectionPointIndex": 0 }, { "key": "34", "locked": false, "zIndex": 0, "points": [ { "x": 7020, "y": 6660 }, { "x": 7740, "y": 7560 } ], "properties": { "endLineEnding": 0 }, "beginItemKey": "3", "beginConnectionPointIndex": 2, "endItemKey": "16", "endConnectionPointIndex": 0 }, { "key": "35", "locked": false, "zIndex": 0, "points": [ { "x": 7740, "y": 8640 }, { "x": 7740, "y": 9000 } ], "properties": { "lineOption": 0, "endLineEnding": 0 }, "beginItemKey": "16", "beginConnectionPointIndex": 2, "endItemKey": "17", "endConnectionPointIndex": 0 }, { "key": "36", "locked": false, "zIndex": 0, "points": [ { "x": 2160, "y": 3240 }, { "x": 720, "y": 3780 } ], "properties": { "endLineEnding": 0 }, "beginItemKey": "12", "beginConnectionPointIndex": 2, "endItemKey": "18", "endConnectionPointIndex": 0 } ], "shapes": [ { "key": "0", "locked": false, "zIndex": 0, "type": "internet", "text": "Internet", "x": 4320, "y": 540, "width": 1080, "height": 1080 }, { "key": "1", "locked": false, "zIndex": 0, "type": "router", "text": "Router", "x": 4320, "y": 2160, "width": 1080, "height": 1080 }, { "key": "2", "locked": false, "zIndex": 0, "type": "switch", "text": "Switch", "x": 2160, "y": 5580, "width": 1080, "height": 1080 }, { "key": "3", "locked": false, "zIndex": 0, "type": "switch", "text": "Switch", "x": 6480, "y": 5580, "width": 1080, "height": 1080 }, { "key": "4", "locked": false, "zIndex": 0, "type": "pc", "text": "PC", "x": 180, "y": 7560, "width": 1080, "height": 1080 }, { "key": "5", "locked": false, "zIndex": 0, "type": "pc", "text": "PC", "x": 1440, "y": 7560, "width": 1080, "height": 1080 }, { "key": "6", "locked": false, "zIndex": 0, "type": "pc", "text": "PC", "x": 2700, "y": 7560, "width": 1080, "height": 1080 }, { "key": "7", "locked": false, "zIndex": 0, "type": "pc", "text": "PC", "x": 3960, "y": 7560, "width": 1080, "height": 1080 }, { "key": "9", "locked": false, "zIndex": 0, "type": "pc", "text": "PC", "x": 5760, "y": 7560, "width": 1080, "height": 1080 }, { "key": "10", "locked": false, "zIndex": 0, "type": "printer", "text": "Printer", "x": 5040, "y": 9000, "width": 1080, "height": 1080 }, { "key": "11", "locked": false, "zIndex": 0, "type": "scaner", "text": "Scaner", "x": 5040, "y": 10440, "width": 1080, "height": 1080 }, { "key": "12", "locked": false, "zIndex": 0, "type": "wifi", "text": "Wi Fi", "x": 1620, "y": 2160, "width": 1080, "height": 1080 }, { "key": "13", "locked": false, "zIndex": 0, "type": "server", "text": "Server", "x": 7020, "y": 2160, "width": 1080, "height": 1080 }, { "key": "14", "locked": false, "zIndex": 0, "type": "laptop", "text": "Laptop", "x": 1620, "y": 3780, "width": 1080, "height": 1080 }, { "key": "15", "locked": false, "zIndex": 0, "type": "mobile", "text": "Mobile", "x": 3060, "y": 3780, "width": 1080, "height": 1080 }, { "key": "16", "locked": false, "zIndex": 0, "type": "pc", "text": "PC", "x": 7200, "y": 7560, "width": 1080, "height": 1080 }, { "key": "17", "locked": false, "zIndex": 0, "type": "phone", "text": "Phone", "x": 7200, "y": 9000, "width": 1080, "height": 1080 }, { "key": "18", "locked": false, "zIndex": 0, "type": "laptop", "text": "Laptop", "x": 180, "y": 3780, "width": 1080, "height": 1080 } ] }
<!DOCTYPE html> <html lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx-diagram.min.css" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" /> <link rel="stylesheet" type="text/css" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.6.3/css/font-awesome.min.css" /> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script> <script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script> <script type="text/javascript" src="config.js"></script> <script type="text/javascript"> System.import("./index.tsx"); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="app"></div> </div> </body> </html>
#diagram { height: 900px; }

Backend API
<dx-diagram #diagram id="diagram">
<dxi-diagram-custom-shape
category="hardware"
type="internet"
title="Internet"
backgroundImageUrl="../../../../images/shapes/internet.svg"
[backgroundImageLeft]="0.15"
[backgroundImageTop]="0"
[backgroundImageWidth]="0.7"
[backgroundImageHeight]="0.7"
[defaultWidth]="0.75"
[defaultHeight]="0.75"
defaultText="Internet"
[allowEditText]="false"
[textLeft]="0"
[textTop]="0.7"
[textWidth]="1"
[textHeight]="0.3"
>
<dxi-diagram-connection-point
[x]="0.5"
[y]="0"
></dxi-diagram-connection-point>
<dxi-diagram-connection-point
[x]="0.9"
[y]="0.5"
></dxi-diagram-connection-point>
<dxi-diagram-connection-point
[x]="0.5"
[y]="1"
></dxi-diagram-connection-point>
<dxi-diagram-connection-point
[x]="0.1"
[y]="0.5"
></dxi-diagram-connection-point>
</dxi-diagram-custom-shape>
<dxi-diagram-custom-shape
category="hardware"
type="laptop"
title="Laptop"
backgroundImageUrl="../../../../images/shapes/laptop.svg"
[backgroundImageLeft]="0.15"
[backgroundImageTop]="0"
[backgroundImageWidth]="0.7"
[backgroundImageHeight]="0.7"
[defaultWidth]="0.75"
[defaultHeight]="0.75"
defaultText="Laptop"
[allowEditText]="true"
[textLeft]="0"
[textTop]="0.7"
[textWidth]="1"
[textHeight]="0.3"
>
<dxi-diagram-connection-point
[x]="0.5"
[y]="0"
></dxi-diagram-connection-point>
<dxi-diagram-connection-point
[x]="0.9"
[y]="0.5"
></dxi-diagram-connection-point>
<dxi-diagram-connection-point
[x]="0.5"
[y]="1"
></dxi-diagram-connection-point>
<dxi-diagram-connection-point
[x]="0.1"
[y]="0.5"
></dxi-diagram-connection-point>
</dxi-diagram-custom-shape>
<dxi-diagram-custom-shape
category="hardware"
type="mobile"
title="Mobile"
backgroundImageUrl="../../../../images/shapes/mobile.svg"
[backgroundImageLeft]="0.15"
[backgroundImageTop]="0"
[backgroundImageWidth]="0.7"
[backgroundImageHeight]="0.7"
[defaultWidth]="0.75"
[defaultHeight]="0.75"
defaultText="Mobile"
[allowEditText]="true"
[textLeft]="0"
[textTop]="0.7"
[textWidth]="1"
[textHeight]="0.3"
>
<dxi-diagram-connection-point
[x]="0.5"
[y]="0"
></dxi-diagram-connection-point>
<dxi-diagram-connection-point
[x]="0.9"
[y]="0.5"
></dxi-diagram-connection-point>
<dxi-diagram-connection-point
[x]="0.5"
[y]="1"
></dxi-diagram-connection-point>
<dxi-diagram-connection-point
[x]="0.1"
[y]="0.5"
></dxi-diagram-connection-point>
</dxi-diagram-custom-shape>
<dxi-diagram-custom-shape
category="hardware"
type="pc"
title="PC"
backgroundImageUrl="../../../../images/shapes/pc.svg"
[backgroundImageLeft]="0.15"
[backgroundImageTop]="0"
[backgroundImageWidth]="0.7"
[backgroundImageHeight]="0.7"
[defaultWidth]="0.75"
[defaultHeight]="0.75"
defaultText="PC"
[allowEditText]="true"
[textLeft]="0"
[textTop]="0.7"
[textWidth]="1"
[textHeight]="0.3"
>
<dxi-diagram-connection-point
[x]="0.5"
[y]="0"
></dxi-diagram-connection-point>
<dxi-diagram-connection-point
[x]="0.9"
[y]="0.5"
></dxi-diagram-connection-point>
<dxi-diagram-connection-point
[x]="0.5"
[y]="1"
></dxi-diagram-connection-point>
<dxi-diagram-connection-point
[x]="0.1"
[y]="0.5"
></dxi-diagram-connection-point>
</dxi-diagram-custom-shape>
<dxi-diagram-custom-shape
category="hardware"
type="phone"
title="Phone"
backgroundImageUrl="../../../../images/shapes/phone.svg"
[backgroundImageLeft]="0.15"
[backgroundImageTop]="0"
[backgroundImageWidth]="0.7"
[backgroundImageHeight]="0.7"
[defaultWidth]="0.75"
[defaultHeight]="0.75"
defaultText="Phone"
[allowEditText]="true"
[textLeft]="0"
[textTop]="0.7"
[textWidth]="1"
[textHeight]="0.3"
>
<dxi-diagram-connection-point
[x]="0.5"
[y]="0"
></dxi-diagram-connection-point>
<dxi-diagram-connection-point
[x]="0.9"
[y]="0.5"
></dxi-diagram-connection-point>
<dxi-diagram-connection-point
[x]="0.5"
[y]="1"
></dxi-diagram-connection-point>
<dxi-diagram-connection-point
[x]="0.1"
[y]="0.5"
></dxi-diagram-connection-point>
</dxi-diagram-custom-shape>
<dxi-diagram-custom-shape
category="hardware"
type="printer"
title="Printer"
backgroundImageUrl="../../../../images/shapes/printer.svg"
[backgroundImageLeft]="0.15"
[backgroundImageTop]="0"
[backgroundImageWidth]="0.7"
[backgroundImageHeight]="0.7"
[defaultWidth]="0.75"
[defaultHeight]="0.75"
defaultText="Printer"
[allowEditText]="true"
[textLeft]="0"
[textTop]="0.7"
[textWidth]="1"
[textHeight]="0.3"
>
<dxi-diagram-connection-point
[x]="0.5"
[y]="0"
></dxi-diagram-connection-point>
<dxi-diagram-connection-point
[x]="0.9"
[y]="0.5"
></dxi-diagram-connection-point>
<dxi-diagram-connection-point
[x]="0.5"
[y]="1"
></dxi-diagram-connection-point>
<dxi-diagram-connection-point
[x]="0.1"
[y]="0.5"
></dxi-diagram-connection-point>
</dxi-diagram-custom-shape>
<dxi-diagram-custom-shape
category="hardware"
type="router"
title="Router"
backgroundImageUrl="../../../../images/shapes/router.svg"
[backgroundImageLeft]="0.15"
[backgroundImageTop]="0"
[backgroundImageWidth]="0.7"
[backgroundImageHeight]="0.7"
[defaultWidth]="0.75"
[defaultHeight]="0.75"
defaultText="Router"
[allowEditText]="true"
[textLeft]="0"
[textTop]="0.7"
[textWidth]="1"
[textHeight]="0.3"
>
</dxi-diagram-custom-shape>
<dxi-diagram-custom-shape
category="hardware"
type="scaner"
title="Scaner"
backgroundImageUrl="../../../../images/shapes/scaner.svg"
[backgroundImageLeft]="0.15"
[backgroundImageTop]="0"
[backgroundImageWidth]="0.7"
[backgroundImageHeight]="0.7"
[defaultWidth]="0.75"
[defaultHeight]="0.75"
defaultText="Scaner"
[allowEditText]="true"
[textLeft]="0"
[textTop]="0.7"
[textWidth]="1"
[textHeight]="0.3"
>
<dxi-diagram-connection-point
[x]="0.5"
[y]="0"
></dxi-diagram-connection-point>
<dxi-diagram-connection-point
[x]="0.9"
[y]="0.5"
></dxi-diagram-connection-point>
<dxi-diagram-connection-point
[x]="0.5"
[y]="1"
></dxi-diagram-connection-point>
<dxi-diagram-connection-point
[x]="0.1"
[y]="0.5"
></dxi-diagram-connection-point>
</dxi-diagram-custom-shape>
<dxi-diagram-custom-shape
category="hardware"
type="server"
title="Server"
backgroundImageUrl="../../../../images/shapes/server.svg"
[backgroundImageLeft]="0.15"
[backgroundImageTop]="0"
[backgroundImageWidth]="0.7"
[backgroundImageHeight]="0.7"
[defaultWidth]="0.75"
[defaultHeight]="0.75"
defaultText="Server"
[allowEditText]="true"
[textLeft]="0"
[textTop]="0.7"
[textWidth]="1"
[textHeight]="0.3"
>
<dxi-diagram-connection-point
[x]="0.5"
[y]="0"
></dxi-diagram-connection-point>
<dxi-diagram-connection-point
[x]="0.9"
[y]="0.5"
></dxi-diagram-connection-point>
<dxi-diagram-connection-point
[x]="0.5"
[y]="1"
></dxi-diagram-connection-point>
<dxi-diagram-connection-point
[x]="0.1"
[y]="0.5"
></dxi-diagram-connection-point>
</dxi-diagram-custom-shape>
<dxi-diagram-custom-shape
category="hardware"
type="switch"
title="Switch"
backgroundImageUrl="../../../../images/shapes/switch.svg"
[backgroundImageLeft]="0.15"
[backgroundImageTop]="0"
[backgroundImageWidth]="0.7"
[backgroundImageHeight]="0.7"
[defaultWidth]="0.75"
[defaultHeight]="0.75"
defaultText="Switch"
[allowEditText]="true"
[textLeft]="0"
[textTop]="0.7"
[textWidth]="1"
[textHeight]="0.3"
>
<dxi-diagram-connection-point
[x]="0.5"
[y]="0"
></dxi-diagram-connection-point>
<dxi-diagram-connection-point
[x]="0.9"
[y]="0.5"
></dxi-diagram-connection-point>
<dxi-diagram-connection-point
[x]="0.5"
[y]="1"
></dxi-diagram-connection-point>
<dxi-diagram-connection-point
[x]="0.1"
[y]="0.5"
></dxi-diagram-connection-point>
</dxi-diagram-custom-shape>
<dxi-diagram-custom-shape
category="hardware"
type="wifi"
title="Wi Fi Router"
backgroundImageUrl="../../../../images/shapes/wifi.svg"
[backgroundImageLeft]="0.15"
[backgroundImageTop]="0"
[backgroundImageWidth]="0.7"
[backgroundImageHeight]="0.7"
[defaultWidth]="0.75"
[defaultHeight]="0.75"
defaultText="Wi Fi"
[allowEditText]="true"
[textLeft]="0"
[textTop]="0.7"
[textWidth]="1"
[textHeight]="0.3"
>
<dxi-diagram-connection-point
[x]="0.5"
[y]="0"
></dxi-diagram-connection-point>
<dxi-diagram-connection-point
[x]="0.9"
[y]="0.5"
></dxi-diagram-connection-point>
<dxi-diagram-connection-point
[x]="0.5"
[y]="1"
></dxi-diagram-connection-point>
<dxi-diagram-connection-point
[x]="0.1"
[y]="0.5"
></dxi-diagram-connection-point>
</dxi-diagram-custom-shape>
<dxo-diagram-toolbox>
<dxi-diagram-group category="hardware" title="Hardware"></dxi-diagram-group>
</dxo-diagram-toolbox>
</dx-diagram>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, ViewChild, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { HttpClient, provideHttpClient, withFetch } from '@angular/common/http';
import { DxDiagramModule, DxDiagramComponent } from 'devextreme-angular';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
preserveWhitespaces: true,
imports: [
DxDiagramModule,
],
})
export class AppComponent {
@ViewChild(DxDiagramComponent, { static: false }) diagram: DxDiagramComponent;
constructor(http: HttpClient) {
http.get('../../../../data/diagram-hardware.json').subscribe({
next: (data) => { this.diagram.instance.import(JSON.stringify(data)); },
error: () => { throw new Error('Data Loading Error'); },
});
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
provideHttpClient(withFetch()),
],
});
::ng-deep #diagram {
height: 900px;
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'demo-ts-shared': 'project:utils/demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.0.2"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx-diagram.min.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>
{
"page": {
"width": 8400,
"height": 11910,
"pageColor": "white",
"pageWidth": 8400,
"pageHeight": 11910,
"pageLandscape": false,
"gridSize": 180,
"showGrid": true,
"snapToGrid": true,
"units": 1
},
"connectors": [
{
"key": "19",
"locked": false,
"zIndex": 0,
"points": [
{
"x": 4860,
"y": 1620
},
{
"x": 4860,
"y": 2160
}
],
"properties": { "endLineEnding": 0 },
"beginItemKey": "0",
"beginConnectionPointIndex": 2,
"endItemKey": "1",
"endConnectionPointIndex": 0
},
{
"key": "20",
"locked": false,
"zIndex": 0,
"points": [
{
"x": 4860,
"y": 3240
},
{
"x": 4860,
"y": 5040
},
{
"x": 3780,
"y": 5040
},
{
"x": 2700,
"y": 5580
}
],
"properties": { "endLineEnding": 0 },
"beginItemKey": "1",
"beginConnectionPointIndex": 2,
"endItemKey": "2",
"endConnectionPointIndex": 0
},
{
"key": "21",
"locked": false,
"zIndex": 0,
"points": [
{
"x": 4860,
"y": 3240
},
{
"x": 4860,
"y": 5040
},
{
"x": 7020,
"y": 5040
},
{
"x": 7020,
"y": 5580
}
],
"properties": { "endLineEnding": 0 },
"beginItemKey": "1",
"beginConnectionPointIndex": 2,
"endItemKey": "3",
"endConnectionPointIndex": 0
},
{
"key": "22",
"locked": false,
"zIndex": 0,
"points": [
{
"x": 2700,
"y": 6660
},
{
"x": 1980,
"y": 7560
}
],
"properties": { "endLineEnding": 0 },
"beginItemKey": "2",
"beginConnectionPointIndex": 2,
"endItemKey": "5",
"endConnectionPointIndex": 0
},
{
"key": "23",
"locked": false,
"zIndex": 0,
"points": [
{
"x": 2700,
"y": 6660
},
{
"x": 3240,
"y": 7560
}
],
"properties": { "endLineEnding": 0 },
"beginItemKey": "2",
"beginConnectionPointIndex": 2,
"endItemKey": "6",
"endConnectionPointIndex": 0
},
{
"key": "24",
"locked": false,
"zIndex": 0,
"points": [
{
"x": 2700,
"y": 6660
},
{
"x": 720,
"y": 7560
}
],
"properties": { "endLineEnding": 0 },
"beginItemKey": "2",
"beginConnectionPointIndex": 2,
"endItemKey": "4",
"endConnectionPointIndex": 0
},
{
"key": "25",
"locked": false,
"zIndex": 0,
"points": [
{
"x": 2700,
"y": 6660
},
{
"x": 4500,
"y": 7560
}
],
"properties": { "endLineEnding": 0 },
"beginItemKey": "2",
"beginConnectionPointIndex": 2,
"endItemKey": "7",
"endConnectionPointIndex": 0
},
{
"key": "27",
"locked": false,
"zIndex": 0,
"points": [
{
"x": 6300,
"y": 8640
},
{
"x": 6300,
"y": 9000
},
{
"x": 6300,
"y": 9540
},
{
"x": 6012,
"y": 9540
}
],
"properties": { "endLineEnding": 0 },
"beginItemKey": "9",
"beginConnectionPointIndex": 2,
"endItemKey": "10",
"endConnectionPointIndex": 1
},
{
"key": "28",
"locked": false,
"zIndex": 0,
"points": [
{
"x": 6300,
"y": 8640
},
{
"x": 6300,
"y": 9000
},
{
"x": 6300,
"y": 10980
},
{
"x": 6012,
"y": 10980
}
],
"properties": { "endLineEnding": 0 },
"beginItemKey": "9",
"beginConnectionPointIndex": 2,
"endItemKey": "11",
"endConnectionPointIndex": 1
},
{
"key": "29",
"locked": false,
"zIndex": 0,
"points": [
{
"x": 7020,
"y": 6660
},
{
"x": 6300,
"y": 7560
}
],
"properties": { "endLineEnding": 0 },
"beginItemKey": "3",
"beginConnectionPointIndex": 2,
"endItemKey": "9",
"endConnectionPointIndex": 0
},
{
"key": "30",
"locked": false,
"zIndex": 0,
"points": [
{
"x": 4320,
"y": 2700
},
{
"x": 2592,
"y": 2700
}
],
"properties": { "endLineEnding": 0 },
"beginItemKey": "1",
"beginConnectionPointIndex": 3,
"endItemKey": "12",
"endConnectionPointIndex": 1
},
{
"key": "31",
"locked": false,
"zIndex": 0,
"points": [
{
"x": 5400,
"y": 2700
},
{
"x": 7128,
"y": 2700
}
],
"properties": { "endLineEnding": 0 },
"beginItemKey": "1",
"beginConnectionPointIndex": 1,
"endItemKey": "13",
"endConnectionPointIndex": 3
},
{
"key": "32",
"locked": false,
"zIndex": 0,
"points": [
{
"x": 2160,
"y": 3240
},
{
"x": 2160,
"y": 3780
}
],
"properties": { "endLineEnding": 0 },
"beginItemKey": "12",
"beginConnectionPointIndex": 2,
"endItemKey": "14",
"endConnectionPointIndex": 0
},
{
"key": "33",
"locked": false,
"zIndex": 0,
"points": [
{
"x": 2160,
"y": 3240
},
{
"x": 3600,
"y": 3780
}
],
"properties": { "endLineEnding": 0 },
"beginItemKey": "12",
"beginConnectionPointIndex": 2,
"endItemKey": "15",
"endConnectionPointIndex": 0
},
{
"key": "34",
"locked": false,
"zIndex": 0,
"points": [
{
"x": 7020,
"y": 6660
},
{
"x": 7740,
"y": 7560
}
],
"properties": { "endLineEnding": 0 },
"beginItemKey": "3",
"beginConnectionPointIndex": 2,
"endItemKey": "16",
"endConnectionPointIndex": 0
},
{
"key": "35",
"locked": false,
"zIndex": 0,
"points": [
{
"x": 7740,
"y": 8640
},
{
"x": 7740,
"y": 9000
}
],
"properties": {
"lineOption": 0,
"endLineEnding": 0
},
"beginItemKey": "16",
"beginConnectionPointIndex": 2,
"endItemKey": "17",
"endConnectionPointIndex": 0
},
{
"key": "36",
"locked": false,
"zIndex": 0,
"points": [
{
"x": 2160,
"y": 3240
},
{
"x": 720,
"y": 3780
}
],
"properties": { "endLineEnding": 0 },
"beginItemKey": "12",
"beginConnectionPointIndex": 2,
"endItemKey": "18",
"endConnectionPointIndex": 0
}
],
"shapes": [
{
"key": "0",
"locked": false,
"zIndex": 0,
"type": "internet",
"text": "Internet",
"x": 4320,
"y": 540,
"width": 1080,
"height": 1080
},
{
"key": "1",
"locked": false,
"zIndex": 0,
"type": "router",
"text": "Router",
"x": 4320,
"y": 2160,
"width": 1080,
"height": 1080
},
{
"key": "2",
"locked": false,
"zIndex": 0,
"type": "switch",
"text": "Switch",
"x": 2160,
"y": 5580,
"width": 1080,
"height": 1080
},
{
"key": "3",
"locked": false,
"zIndex": 0,
"type": "switch",
"text": "Switch",
"x": 6480,
"y": 5580,
"width": 1080,
"height": 1080
},
{
"key": "4",
"locked": false,
"zIndex": 0,
"type": "pc",
"text": "PC",
"x": 180,
"y": 7560,
"width": 1080,
"height": 1080
},
{
"key": "5",
"locked": false,
"zIndex": 0,
"type": "pc",
"text": "PC",
"x": 1440,
"y": 7560,
"width": 1080,
"height": 1080
},
{
"key": "6",
"locked": false,
"zIndex": 0,
"type": "pc",
"text": "PC",
"x": 2700,
"y": 7560,
"width": 1080,
"height": 1080
},
{
"key": "7",
"locked": false,
"zIndex": 0,
"type": "pc",
"text": "PC",
"x": 3960,
"y": 7560,
"width": 1080,
"height": 1080
},
{
"key": "9",
"locked": false,
"zIndex": 0,
"type": "pc",
"text": "PC",
"x": 5760,
"y": 7560,
"width": 1080,
"height": 1080
},
{
"key": "10",
"locked": false,
"zIndex": 0,
"type": "printer",
"text": "Printer",
"x": 5040,
"y": 9000,
"width": 1080,
"height": 1080
},
{
"key": "11",
"locked": false,
"zIndex": 0,
"type": "scaner",
"text": "Scaner",
"x": 5040,
"y": 10440,
"width": 1080,
"height": 1080
},
{
"key": "12",
"locked": false,
"zIndex": 0,
"type": "wifi",
"text": "Wi Fi",
"x": 1620,
"y": 2160,
"width": 1080,
"height": 1080
},
{
"key": "13",
"locked": false,
"zIndex": 0,
"type": "server",
"text": "Server",
"x": 7020,
"y": 2160,
"width": 1080,
"height": 1080
},
{
"key": "14",
"locked": false,
"zIndex": 0,
"type": "laptop",
"text": "Laptop",
"x": 1620,
"y": 3780,
"width": 1080,
"height": 1080
},
{
"key": "15",
"locked": false,
"zIndex": 0,
"type": "mobile",
"text": "Mobile",
"x": 3060,
"y": 3780,
"width": 1080,
"height": 1080
},
{
"key": "16",
"locked": false,
"zIndex": 0,
"type": "pc",
"text": "PC",
"x": 7200,
"y": 7560,
"width": 1080,
"height": 1080
},
{
"key": "17",
"locked": false,
"zIndex": 0,
"type": "phone",
"text": "Phone",
"x": 7200,
"y": 9000,
"width": 1080,
"height": 1080
},
{
"key": "18",
"locked": false,
"zIndex": 0,
"type": "laptop",
"text": "Laptop",
"x": 180,
"y": 3780,
"width": 1080,
"height": 1080
}
]
}

Backend API
<template>
<DxDiagram
id="diagram"
ref="diagram"
>
<DxCustomShape
:category="'hardware'"
:type="'internet'"
:title="'Internet'"
:background-image-url="'../../../../images/shapes/internet.svg'"
:background-image-left="0.15"
:background-image-top="0"
:background-image-width="0.7"
:background-image-height="0.7"
:default-width="0.75"
:default-height="0.75"
:default-text="'Internet'"
:allow-edit-text="true"
:text-left="0"
:text-top="0.7"
:text-width="1"
:text-height="0.3"
>
<DxConnectionPoint
:x="0.5"
:y="0"
/>
<DxConnectionPoint
:x="0.9"
:y="0.5"
/>
<DxConnectionPoint
:x="0.5"
:y="1"
/>
<DxConnectionPoint
:x="0.1"
:y="0.5"
/>
</DxCustomShape>
<DxCustomShape
:category="'hardware'"
:type="'laptop'"
:title="'Laptop'"
:background-image-url="'../../../../images/shapes/laptop.svg'"
:background-image-left="0.15"
:background-image-top="0"
:background-image-width="0.7"
:background-image-height="0.7"
:default-width="0.75"
:default-height="0.75"
:default-text="'Laptop'"
:allow-edit-text="true"
:text-left="0"
:text-top="0.7"
:text-width="1"
:text-height="0.3"
>
<DxConnectionPoint
:x="0.5"
:y="0"
/>
<DxConnectionPoint
:x="0.9"
:y="0.5"
/>
<DxConnectionPoint
:x="0.5"
:y="1"
/>
<DxConnectionPoint
:x="0.1"
:y="0.5"
/>
</DxCustomShape>
<DxCustomShape
:category="'hardware'"
:type="'mobile'"
:title="'Mobile'"
:background-image-url="'../../../../images/shapes/mobile.svg'"
:background-image-left="0.15"
:background-image-top="0"
:background-image-width="0.7"
:background-image-height="0.7"
:default-width="0.75"
:default-height="0.75"
:default-text="'Mobile'"
:allow-edit-text="true"
:text-left="0"
:text-top="0.7"
:text-width="1"
:text-height="0.3"
>
<DxConnectionPoint
:x="0.5"
:y="0"
/>
<DxConnectionPoint
:x="0.9"
:y="0.5"
/>
<DxConnectionPoint
:x="0.5"
:y="1"
/>
<DxConnectionPoint
:x="0.1"
:y="0.5"
/>
</DxCustomShape>
<DxCustomShape
:category="'hardware'"
:type="'pc'"
:title="'PC'"
:background-image-url="'../../../../images/shapes/pc.svg'"
:background-image-left="0.15"
:background-image-top="0"
:background-image-width="0.7"
:background-image-height="0.7"
:default-width="0.75"
:default-height="0.75"
:default-text="'PC'"
:allow-edit-text="true"
:text-left="0"
:text-top="0.7"
:text-width="1"
:text-height="0.3"
>
<DxConnectionPoint
:x="0.5"
:y="0"
/>
<DxConnectionPoint
:x="0.9"
:y="0.5"
/>
<DxConnectionPoint
:x="0.5"
:y="1"
/>
<DxConnectionPoint
:x="0.1"
:y="0.5"
/>
</DxCustomShape>
<DxCustomShape
:category="'hardware'"
:type="'phone'"
:title="'Phone'"
:background-image-url="'../../../../images/shapes/phone.svg'"
:background-image-left="0.15"
:background-image-top="0"
:background-image-width="0.7"
:background-image-height="0.7"
:default-width="0.75"
:default-height="0.75"
:default-text="'Phone'"
:allow-edit-text="true"
:text-left="0"
:text-top="0.7"
:text-width="1"
:text-height="0.3"
>
<DxConnectionPoint
:x="0.5"
:y="0"
/>
<DxConnectionPoint
:x="0.9"
:y="0.5"
/>
<DxConnectionPoint
:x="0.5"
:y="1"
/>
<DxConnectionPoint
:x="0.1"
:y="0.5"
/>
</DxCustomShape>
<DxCustomShape
:category="'hardware'"
:type="'printer'"
:title="'Printer'"
:background-image-url="'../../../../images/shapes/printer.svg'"
:background-image-left="0.15"
:background-image-top="0"
:background-image-width="0.7"
:background-image-height="0.7"
:default-width="0.75"
:default-height="0.75"
:default-text="'Printer'"
:allow-edit-text="true"
:text-left="0"
:text-top="0.7"
:text-width="1"
:text-height="0.3"
>
<DxConnectionPoint
:x="0.5"
:y="0"
/>
<DxConnectionPoint
:x="0.9"
:y="0.5"
/>
<DxConnectionPoint
:x="0.5"
:y="1"
/>
<DxConnectionPoint
:x="0.1"
:y="0.5"
/>
</DxCustomShape>
<DxCustomShape
:category="'hardware'"
:type="'router'"
:title="'Router'"
:background-image-url="'../../../../images/shapes/router.svg'"
:background-image-left="0.15"
:background-image-top="0"
:background-image-width="0.7"
:background-image-height="0.7"
:default-width="0.75"
:default-height="0.75"
:default-text="'Router'"
:allow-edit-text="true"
:text-left="0"
:text-top="0.7"
:text-width="1"
:text-height="0.3"
/>
<DxCustomShape
:category="'hardware'"
:type="'scaner'"
:title="'Scaner'"
:background-image-url="'../../../../images/shapes/scaner.svg'"
:background-image-left="0.15"
:background-image-top="0"
:background-image-width="0.7"
:background-image-height="0.7"
:default-width="0.75"
:default-height="0.75"
:default-text="'Scaner'"
:allow-edit-text="true"
:text-left="0"
:text-top="0.7"
:text-width="1"
:text-height="0.3"
>
<DxConnectionPoint
:x="0.5"
:y="0"
/>
<DxConnectionPoint
:x="0.9"
:y="0.5"
/>
<DxConnectionPoint
:x="0.5"
:y="1"
/>
<DxConnectionPoint
:x="0.1"
:y="0.5"
/>
</DxCustomShape>
<DxCustomShape
:category="'hardware'"
:type="'server'"
:title="'Server'"
:background-image-url="'../../../../images/shapes/server.svg'"
:background-image-left="0.15"
:background-image-top="0"
:background-image-width="0.7"
:background-image-height="0.7"
:default-width="0.75"
:default-height="0.75"
:default-text="'Server'"
:allow-edit-text="true"
:text-left="0"
:text-top="0.7"
:text-width="1"
:text-height="0.3"
>
<DxConnectionPoint
:x="0.5"
:y="0"
/>
<DxConnectionPoint
:x="0.9"
:y="0.5"
/>
<DxConnectionPoint
:x="0.5"
:y="1"
/>
<DxConnectionPoint
:x="0.1"
:y="0.5"
/>
</DxCustomShape>
<DxCustomShape
:category="'hardware'"
:type="'switch'"
:title="'Switch'"
:background-image-url="'../../../../images/shapes/switch.svg'"
:background-image-left="0.15"
:background-image-top="0"
:background-image-width="0.7"
:background-image-height="0.7"
:default-width="0.75"
:default-height="0.75"
:default-text="'Switch'"
:allow-edit-text="true"
:text-left="0"
:text-top="0.7"
:text-width="1"
:text-height="0.3"
>
<DxConnectionPoint
:x="0.5"
:y="0"
/>
<DxConnectionPoint
:x="0.9"
:y="0.5"
/>
<DxConnectionPoint
:x="0.5"
:y="1"
/>
<DxConnectionPoint
:x="0.1"
:y="0.5"
/>
</DxCustomShape>
<DxCustomShape
:category="'hardware'"
:type="'wifi'"
:title="'Wi Fi Router'"
:background-image-url="'../../../../images/shapes/wifi.svg'"
:background-image-left="0.15"
:background-image-top="0"
:background-image-width="0.7"
:background-image-height="0.7"
:default-width="0.75"
:default-height="0.75"
:default-text="'Wi Fi'"
:allow-edit-text="true"
:text-left="0"
:text-top="0.7"
:text-width="1"
:text-height="0.3"
>
<DxConnectionPoint
:x="0.5"
:y="0"
/>
<DxConnectionPoint
:x="0.9"
:y="0.5"
/>
<DxConnectionPoint
:x="0.5"
:y="1"
/>
<DxConnectionPoint
:x="0.1"
:y="0.5"
/>
</DxCustomShape>
<DxToolbox :visible="true">
<DxGroup
:category="'hardware'"
:title="'Hardware'"
/>
</DxToolbox>
</DxDiagram>
</template>
<script setup lang="ts">
import { watch, ref } from 'vue';
import {
DxDiagram, DxGroup, DxToolbox, DxCustomShape, DxConnectionPoint,
} from 'devextreme-vue/diagram';
import 'whatwg-fetch';
const diagram = ref();
watch(
diagram,
({ instance }) => {
fetch('../../../../data/diagram-hardware.json')
.then((response) => response.json())
.then((json) => {
instance.import(JSON.stringify(json));
})
.catch(() => {
throw new Error('Data Loading Error');
});
},
);
</script>
<style scoped>
#diagram {
height: 900px;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'typescript': {
'exports': 'ts',
},
'vue': {
format: 'global',
exports: 'Vue',
esModule: true,
},
'vuex': {
format: 'global',
exports: 'Vuex',
esModule: true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.32/dist/vue.global.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'project:utils/demo-vue-loader.js',
'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'demo-ts-shared': 'project:utils/demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'whatwg-fetch': 'npm:whatwg-fetch@2.0.4/fetch.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx-diagram.min.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.6.3/css/font-awesome.min.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>
{
"page": {
"width": 8400,
"height": 11910,
"pageColor": "white",
"pageWidth": 8400,
"pageHeight": 11910,
"pageLandscape": false,
"gridSize": 180,
"showGrid": true,
"snapToGrid": true,
"units": 1
},
"connectors": [
{
"key": "19",
"locked": false,
"zIndex": 0,
"points": [
{
"x": 4860,
"y": 1620
},
{
"x": 4860,
"y": 2160
}
],
"properties": { "endLineEnding": 0 },
"beginItemKey": "0",
"beginConnectionPointIndex": 2,
"endItemKey": "1",
"endConnectionPointIndex": 0
},
{
"key": "20",
"locked": false,
"zIndex": 0,
"points": [
{
"x": 4860,
"y": 3240
},
{
"x": 4860,
"y": 5040
},
{
"x": 3780,
"y": 5040
},
{
"x": 2700,
"y": 5580
}
],
"properties": { "endLineEnding": 0 },
"beginItemKey": "1",
"beginConnectionPointIndex": 2,
"endItemKey": "2",
"endConnectionPointIndex": 0
},
{
"key": "21",
"locked": false,
"zIndex": 0,
"points": [
{
"x": 4860,
"y": 3240
},
{
"x": 4860,
"y": 5040
},
{
"x": 7020,
"y": 5040
},
{
"x": 7020,
"y": 5580
}
],
"properties": { "endLineEnding": 0 },
"beginItemKey": "1",
"beginConnectionPointIndex": 2,
"endItemKey": "3",
"endConnectionPointIndex": 0
},
{
"key": "22",
"locked": false,
"zIndex": 0,
"points": [
{
"x": 2700,
"y": 6660
},
{
"x": 1980,
"y": 7560
}
],
"properties": { "endLineEnding": 0 },
"beginItemKey": "2",
"beginConnectionPointIndex": 2,
"endItemKey": "5",
"endConnectionPointIndex": 0
},
{
"key": "23",
"locked": false,
"zIndex": 0,
"points": [
{
"x": 2700,
"y": 6660
},
{
"x": 3240,
"y": 7560
}
],
"properties": { "endLineEnding": 0 },
"beginItemKey": "2",
"beginConnectionPointIndex": 2,
"endItemKey": "6",
"endConnectionPointIndex": 0
},
{
"key": "24",
"locked": false,
"zIndex": 0,
"points": [
{
"x": 2700,
"y": 6660
},
{
"x": 720,
"y": 7560
}
],
"properties": { "endLineEnding": 0 },
"beginItemKey": "2",
"beginConnectionPointIndex": 2,
"endItemKey": "4",
"endConnectionPointIndex": 0
},
{
"key": "25",
"locked": false,
"zIndex": 0,
"points": [
{
"x": 2700,
"y": 6660
},
{
"x": 4500,
"y": 7560
}
],
"properties": { "endLineEnding": 0 },
"beginItemKey": "2",
"beginConnectionPointIndex": 2,
"endItemKey": "7",
"endConnectionPointIndex": 0
},
{
"key": "27",
"locked": false,
"zIndex": 0,
"points": [
{
"x": 6300,
"y": 8640
},
{
"x": 6300,
"y": 9000
},
{
"x": 6300,
"y": 9540
},
{
"x": 6012,
"y": 9540
}
],
"properties": { "endLineEnding": 0 },
"beginItemKey": "9",
"beginConnectionPointIndex": 2,
"endItemKey": "10",
"endConnectionPointIndex": 1
},
{
"key": "28",
"locked": false,
"zIndex": 0,
"points": [
{
"x": 6300,
"y": 8640
},
{
"x": 6300,
"y": 9000
},
{
"x": 6300,
"y": 10980
},
{
"x": 6012,
"y": 10980
}
],
"properties": { "endLineEnding": 0 },
"beginItemKey": "9",
"beginConnectionPointIndex": 2,
"endItemKey": "11",
"endConnectionPointIndex": 1
},
{
"key": "29",
"locked": false,
"zIndex": 0,
"points": [
{
"x": 7020,
"y": 6660
},
{
"x": 6300,
"y": 7560
}
],
"properties": { "endLineEnding": 0 },
"beginItemKey": "3",
"beginConnectionPointIndex": 2,
"endItemKey": "9",
"endConnectionPointIndex": 0
},
{
"key": "30",
"locked": false,
"zIndex": 0,
"points": [
{
"x": 4320,
"y": 2700
},
{
"x": 2592,
"y": 2700
}
],
"properties": { "endLineEnding": 0 },
"beginItemKey": "1",
"beginConnectionPointIndex": 3,
"endItemKey": "12",
"endConnectionPointIndex": 1
},
{
"key": "31",
"locked": false,
"zIndex": 0,
"points": [
{
"x": 5400,
"y": 2700
},
{
"x": 7128,
"y": 2700
}
],
"properties": { "endLineEnding": 0 },
"beginItemKey": "1",
"beginConnectionPointIndex": 1,
"endItemKey": "13",
"endConnectionPointIndex": 3
},
{
"key": "32",
"locked": false,
"zIndex": 0,
"points": [
{
"x": 2160,
"y": 3240
},
{
"x": 2160,
"y": 3780
}
],
"properties": { "endLineEnding": 0 },
"beginItemKey": "12",
"beginConnectionPointIndex": 2,
"endItemKey": "14",
"endConnectionPointIndex": 0
},
{
"key": "33",
"locked": false,
"zIndex": 0,
"points": [
{
"x": 2160,
"y": 3240
},
{
"x": 3600,
"y": 3780
}
],
"properties": { "endLineEnding": 0 },
"beginItemKey": "12",
"beginConnectionPointIndex": 2,
"endItemKey": "15",
"endConnectionPointIndex": 0
},
{
"key": "34",
"locked": false,
"zIndex": 0,
"points": [
{
"x": 7020,
"y": 6660
},
{
"x": 7740,
"y": 7560
}
],
"properties": { "endLineEnding": 0 },
"beginItemKey": "3",
"beginConnectionPointIndex": 2,
"endItemKey": "16",
"endConnectionPointIndex": 0
},
{
"key": "35",
"locked": false,
"zIndex": 0,
"points": [
{
"x": 7740,
"y": 8640
},
{
"x": 7740,
"y": 9000
}
],
"properties": {
"lineOption": 0,
"endLineEnding": 0
},
"beginItemKey": "16",
"beginConnectionPointIndex": 2,
"endItemKey": "17",
"endConnectionPointIndex": 0
},
{
"key": "36",
"locked": false,
"zIndex": 0,
"points": [
{
"x": 2160,
"y": 3240
},
{
"x": 720,
"y": 3780
}
],
"properties": { "endLineEnding": 0 },
"beginItemKey": "12",
"beginConnectionPointIndex": 2,
"endItemKey": "18",
"endConnectionPointIndex": 0
}
],
"shapes": [
{
"key": "0",
"locked": false,
"zIndex": 0,
"type": "internet",
"text": "Internet",
"x": 4320,
"y": 540,
"width": 1080,
"height": 1080
},
{
"key": "1",
"locked": false,
"zIndex": 0,
"type": "router",
"text": "Router",
"x": 4320,
"y": 2160,
"width": 1080,
"height": 1080
},
{
"key": "2",
"locked": false,
"zIndex": 0,
"type": "switch",
"text": "Switch",
"x": 2160,
"y": 5580,
"width": 1080,
"height": 1080
},
{
"key": "3",
"locked": false,
"zIndex": 0,
"type": "switch",
"text": "Switch",
"x": 6480,
"y": 5580,
"width": 1080,
"height": 1080
},
{
"key": "4",
"locked": false,
"zIndex": 0,
"type": "pc",
"text": "PC",
"x": 180,
"y": 7560,
"width": 1080,
"height": 1080
},
{
"key": "5",
"locked": false,
"zIndex": 0,
"type": "pc",
"text": "PC",
"x": 1440,
"y": 7560,
"width": 1080,
"height": 1080
},
{
"key": "6",
"locked": false,
"zIndex": 0,
"type": "pc",
"text": "PC",
"x": 2700,
"y": 7560,
"width": 1080,
"height": 1080
},
{
"key": "7",
"locked": false,
"zIndex": 0,
"type": "pc",
"text": "PC",
"x": 3960,
"y": 7560,
"width": 1080,
"height": 1080
},
{
"key": "9",
"locked": false,
"zIndex": 0,
"type": "pc",
"text": "PC",
"x": 5760,
"y": 7560,
"width": 1080,
"height": 1080
},
{
"key": "10",
"locked": false,
"zIndex": 0,
"type": "printer",
"text": "Printer",
"x": 5040,
"y": 9000,
"width": 1080,
"height": 1080
},
{
"key": "11",
"locked": false,
"zIndex": 0,
"type": "scaner",
"text": "Scaner",
"x": 5040,
"y": 10440,
"width": 1080,
"height": 1080
},
{
"key": "12",
"locked": false,
"zIndex": 0,
"type": "wifi",
"text": "Wi Fi",
"x": 1620,
"y": 2160,
"width": 1080,
"height": 1080
},
{
"key": "13",
"locked": false,
"zIndex": 0,
"type": "server",
"text": "Server",
"x": 7020,
"y": 2160,
"width": 1080,
"height": 1080
},
{
"key": "14",
"locked": false,
"zIndex": 0,
"type": "laptop",
"text": "Laptop",
"x": 1620,
"y": 3780,
"width": 1080,
"height": 1080
},
{
"key": "15",
"locked": false,
"zIndex": 0,
"type": "mobile",
"text": "Mobile",
"x": 3060,
"y": 3780,
"width": 1080,
"height": 1080
},
{
"key": "16",
"locked": false,
"zIndex": 0,
"type": "pc",
"text": "PC",
"x": 7200,
"y": 7560,
"width": 1080,
"height": 1080
},
{
"key": "17",
"locked": false,
"zIndex": 0,
"type": "phone",
"text": "Phone",
"x": 7200,
"y": 9000,
"width": 1080,
"height": 1080
},
{
"key": "18",
"locked": false,
"zIndex": 0,
"type": "laptop",
"text": "Laptop",
"x": 180,
"y": 3780,
"width": 1080,
"height": 1080
}
]
}